import 'package:get/get.dart';
import 'package:getx_extended/controller/export.dart';
import 'package:uuid/uuid.dart';

class TaskController extends GetxController with CountableController {
  static Function(dynamic error, StackTrace trace) stackTraceLogger =
      (error, trace) {};
  RxList<dynamic> errors = RxList();

  Future<T> enqueue<T>(
    Future<T> Function() task, {
    Duration autoComplete = const Duration(seconds: 5),
  }) {
    final uuid = Uuid().v4();
    add(uuid, autoComplete: autoComplete);
    return task()
        .catchError(
          catchErrorWithStackTrace,
        )
        .whenComplete(
          () => complete(uuid),
        );
  }

  dynamic catchErrorWithStackTrace(error, StackTrace stacktrace) {
    stackTraceLogger(error, stacktrace);
    return catchError(error);
  }

  dynamic catchError(error) {
    errors.add(error);
    return error;
  }

  void dismiss(dynamic error) => errors.remove(error);
}
