import 'dart:async';

import 'package:flutter/material.dart';

mixin AutoDisposableState<T extends StatefulWidget> on State<T> {
  List<StreamSubscription> _streams = [];

  @override
  void dispose() {
    _streams
      ..forEach((element) => element.cancel())
      ..clear();
    super.dispose();
  }

  void autoDispose(StreamSubscription subscription) =>
      _streams.add(subscription);
}
